!----------------------------------------------------------------------
!     Copyright (c) 2002 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!ɽ  wt_module
!      ®٥ȥȻ
!
!  2002/02/04  ݹ
!      2002/04/11  ݹ  ⥸塼̾ѹ
!      2002/08/24  ݹ  ⥸塼̾ѹ
!
program wt_diff2

  use wt_module
  use gtool_history
  implicit none

 !---- ֲ ----
  integer,parameter  :: im=32, jm=16, km=16  ! ʻ(, , ư)
  integer,parameter  :: nm=10, lm=16         ! ȿ(ʿ, ư)

 !---- ɸѿʤ ----
  real(8),parameter  :: ri=0.5, ro=1.5       ! ⳰Ⱦ

 !---- ѿ ----
  real(8), dimension(im,jm,0:km)     :: xyz_Torvel   ! ȥ®
  real(8), dimension((nm+1)**2,0:lm) :: wt_Torvel    ! ȥ®
  real(8), dimension((nm+1)**2,0:lm) :: wt_Torvelr   ! ȥ®/r

 !---- ʬѥ᥿ ----
  real(8), parameter :: dt=1e-5                 ! ֥ƥå״ֳ
  integer, parameter :: nt=10000, ndisp=1000    ! ʬ, ɽƥå

 !---- ʪѥ᥿ ----
  character(len=2), parameter :: TvBC='FF'      ! ®ٶ(FF/FR/RF/RR)
  real(8), parameter :: nu=1.0                  ! Ǵ

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: Lon1=pi                 ! ʬ۰ٺɸ
  real(8), parameter :: Lat1=0.0                ! ʬ۷ٺɸ
  real(8), parameter :: Rad1=(ri+ro)/2.0        ! ʬưºɸ
  real(8), parameter :: Sigma=0.2               ! ʬۤ礭

 !---- ¾ ----
  integer :: it

 !---------------- ɸͤ ---------------------
  call wt_Initial(im,jm,km,nm,lm,ri,ro)

 !-------------------  ----------------------
  xyz_Torvel =  exp(-((xyz_Lon-Lon1)**2+(xyz_Lat-Lat1)**2+(xyz_Rad-Rad1)**2)&
                 /(2*Sigma**2))
  wt_Torvel = wt_xyz(xyz_Torvel)

  call output_gtool4_init
  call output_gtool4

 !------------------- ʬ ----------------------
  do it=1,nt                                         ! Euler ˡˤʬ
     wt_Torvel = wt_Torvel + dt *( nu * wt_Lapla_wt(wt_Torvel))

     call wt_TorBoundaries(wt_Torvel,TvBC)

     if(mod(it,ndisp) .eq. 0)then                    ! 
        xyz_Torvel = xyz_wt(wt_Torvel)
        call output_gtool4
     endif
  enddo
  call output_gtool4_close

contains

  subroutine output_gtool4_init
    call HistoryCreate( &                                  ! ҥȥ꡼
           file='wt_diff2.nc', title='Diffusion model in a spherical shell', &
           source='Sample program of spmodel library', &
           institution='GFD_Dennou Club SPMODEL project',     &
           dims=(/'lon','lat','rad','t  '/), dimsizes=(/im,jm,km+1,0/),&
           longnames=(/'Longitude','Latitude ','Radius   ','time     '/),&
           units=(/'1','1','1','1'/),   &
           origin=0.0, interval=real(ndisp*dt) )

    call HistoryPut('lon',x_Lon/pi*180)                       ! ѿ
    call HistoryPut('lat',y_Lat/pi*180)                       ! ѿ
    call HistoryPut('rad',z_Rad)                              ! ѿ

    call HistoryAddVariable( &                                ! ѿ
           varname='torvel', dims=(/'lon','lat','rad','t  '/), & 
           longname='toriodal velocity potential', units='1', xtype='double')
  end subroutine output_gtool4_init

  subroutine output_gtool4
    write(6,*) 'it = ',it
    call HistoryPut('t',real(it*dt))
    call HistoryPut('torvel',xyz_Torvel)
  end subroutine output_gtool4

  subroutine output_gtool4_close
    call HistoryClose
  end subroutine output_gtool4_close

end program wt_diff2
